#include "types.h"
#include <stdlib.h>

void DFS(Node *nodes, int start_index, int *using);

Node *GenGraph(int nodes_n, int edges_n, int up_border)
{
    Node *graph = calloc(nodes_n, sizeof(Node));
    int *used   = calloc(nodes_n, sizeof(int));
    int *unused = calloc(nodes_n, sizeof(int)); 
    int i;
    int unused_counter;

    for(i = 0; i < nodes_n; i++) {
        used[i] = 0;

        Edge *head = calloc(1, sizeof(Edge));

        head -> to = NULL;
        head -> weight = 0;
        head -> next   = NULL; 

        graph[i].SKP = inf;
        graph[i].edges_num = 0;
        graph[i].edges = head;
        graph[i].graph_index = i;
        graph[i].last  = head;
        graph[i].index = 0;
    }


    Edge *from_zero = calloc(1, sizeof(Edge));
    int weight = rand()%up_border + 1;
    from_zero -> to = graph+(rand()%nodes_n);
    from_zero -> weight = weight;

    graph[0].last -> next = from_zero;
    graph[0].last = from_zero;

    for(i = 0; i < edges_n; i++)
    {
        int node_index_from, node_index_to; 
        int weight;
        node_index_from = rand()%nodes_n;
        node_index_to   = rand()%nodes_n;
        weight          = rand()%up_border + 1;

        Edge *edg = calloc(1, sizeof(Edge));

        edg -> to = graph+node_index_to;
        edg -> weight = weight;
        edg -> next = NULL;

        graph[node_index_from].last -> next = edg;
        graph[node_index_from].last = edg;
    }

    unused_counter = 0;

    for(i = 0; i < nodes_n; i++)
    {
        if(used[i] != 1)
        {
            DFS(graph, i, used);
            unused[unused_counter++] = i;
        }
    }

    for(i = 0; i < unused_counter - 1; i++)
    {
        int j;
        for(j = i +1; j < unused_counter; j++)
        {
            Edge *to_i = (Edge *)calloc(1, sizeof(Edge));
            Edge *to_j = (Edge *)calloc(1, sizeof(Edge));

            Node *i_node = &graph[unused[i]];
            Node *j_node = &graph[unused[j]];
            
            to_i -> weight = rand() %up_border;
            to_j -> weight = rand() %up_border;

            to_i -> next = NULL;
            to_j -> next = NULL;

            to_i -> to = i_node;
            to_j -> to = j_node;

            i_node -> last -> next = to_j;
            i_node -> last = to_j;

            j_node -> last -> next = to_i;
            j_node -> last = to_i;
        }
    }

    return graph;
}

void DFS(Node *nodes, int start_index, int *using)
{
    int i;

    using[start_index] = 1;
    Edge *edge = nodes[start_index].edges -> next;

    while(edge != NULL)
    {
        int currIndex = edge -> to -> graph_index;
        if(using[currIndex] != 1)
            DFS(nodes, currIndex, using);

        edge = edge -> next;  
    }
    
}
