#include <vector>
#include "DSU.h"

using namespace std;

DSU::DSU(int size)
{
    parrent_tree = vector<int>(size);
    rank         = vector<int>(size);
}

void DSU::SetUnion(int fst, int snd)
{
    int fstSet = SetFind(fst);
    int sndSet = SetFind(snd);

    if(fstSet != sndSet)
    {
        if(rank[fstSet] < rank[sndSet])
        {
            int swap_tmp = fstSet;
            fstSet = sndSet;
            sndSet = swap_tmp;
        }

        parrent_tree[sndSet] = fstSet;

        if(rank[fstSet] == rank[sndSet])
            ++rank[fstSet];
    }
}

int DSU::SetFind(int item)
{
    if(item == parrent_tree[item]) return item;
    
    return parrent_tree[item] = SetFind(parrent_tree[item]);
}

void DSU::SetCreate(int item)
{
    parrent_tree[item] = item;
    rank[item] = 0;
}
