#include <iostream>
#include <vector>
#include <stdio.h>
#include <stdlib.h>
#include "types.h"

using namespace std;

typedef pair<int,int> vEdge;
typedef vector< vector<vEdge> > vGraph;


Node *toNodeView(vGraph &graph);

void DFS(int index, vGraph &graph, vector<bool> &use)
{
    use[index] = true;

    for(int i = 0; i < graph[index].size(); i++)
    {
        int gIndex = graph[index][i].first;
        if(!use[gIndex])
            DFS(gIndex, graph, use);
    }
}

Node *GenGraph(int nodes_n, int edges_num, int up)
{
    vGraph graph(nodes_n);
    vector<bool> use(nodes_n, 0);
    vector<int>  unreach_indexes;
    int i;

    for(i = 0; i < edges_num; i++)
    {
        int rand_index = rand() % nodes_n;

        vEdge new_edge(rand() % nodes_n, rand() % up);
        graph[rand_index].push_back(new_edge);
    }

    for(i = 0; i < nodes_n; i++)
    {
        if(!use[i])
        {
            DFS(i, graph, use);
            unreach_indexes.push_back(i);
        }
    }

    for(i = 0; i < unreach_indexes.size() - 1; i++)
    {
        for(int j = i + 1; j < unreach_indexes.size(); j++)
        {
            int fst_index = unreach_indexes[i];
            int snd_index = unreach_indexes[j];

            graph[fst_index].push_back(vEdge(snd_index, rand() % up));
            graph[snd_index].push_back(vEdge(fst_index, rand() % up));
        }
    }

    return toNodeView(graph);
}

Edge *getEdgesArray(vector<vEdge> &i_edges);

Node *toNodeView(vGraph &graph)
{
    Node *nodes = (Node *)calloc(graph.size(), sizeof(Node));

    for(int i = 0; i < graph.size(); i++)
    {
        nodes[i].used = 0;
        nodes[i].n = graph[i].size();
        nodes[i].edges = getEdgesArray(graph[i]);
    }

    return nodes;
}

Edge *getEdgesArray(vector<vEdge> &i_edges)
{
    Edge *edges = (Edge *)calloc(i_edges.size(), sizeof(Edge));

    for(int i = 0; i < i_edges.size(); i++)
    {
       edges[i].weight = i_edges[i].second;
       edges[i].to = i_edges[i].first;
    }

    return edges;
}

