#include <stdio.h>
#include <time.h>
#include "types.h"
#include "GraphGen.h"
#include "prim.h"
#include <stdlib.h>

void printGraph(Node *gr, int n);
const int NANO_SECONDS_IN_SEC = 1000000000;
struct timespec *diff(struct timespec start,struct timespec end);
unsigned long long doWork(Node *graph, int n);

int main()
{
    time_t t;
    srand((unsigned)time(&t));

    const int NANO_SECONDS_IN_SEC = 1000000000;
    int n;
    int m;
    int r;
    int i;
    unsigned long long time = 0;
    const int rep_num = 100;


    scanf("%d %d %d", &n, &m, &r);
    
    Node *graph = GenGraph(n, m, r);
   
    for(i = 0; i < 20; i++)
    {
       doWork(graph, n); 
    }

    for(i = 0; i < rep_num; i++)
    {
        time += doWork(graph, n);
    }

    printf("%Lu", time/rep_num);

    return 0;
}
void printGraph(Node *gr, int n)
{
   int i;

   for(i = 0; i < n; i++)
   {
       Node *currPtr = gr + i;

       printf("Node %d\n", i);
       int edges_limit = currPtr -> n;
       int edge_index = 0;
       Edge *edges = currPtr -> edges;

       for(edge_index = 0; edge_index < edges_limit; ++edge_index)
           printf("\tEdge to %d weight %d\n", edges[edge_index].to, edges[edge_index].weight);
   }
}

struct timespec *diff(struct timespec start,struct timespec end)
{
    struct timespec temp;
    if ((end.tv_nsec-start.tv_nsec)<0) {
            temp.tv_sec = end.tv_sec-start.tv_sec-1;
            temp.tv_nsec = 1000000000+end.tv_nsec-start.tv_nsec;
        } else {
                temp.tv_sec = end.tv_sec-start.tv_sec;
                temp.tv_nsec = end.tv_nsec-start.tv_nsec;
            }
    return &temp;
}

unsigned long long doWork(Node *graph, int n)
{
    struct timespec before;
    struct timespec after;

    clock_gettime(CLOCK_PROCESS_CPUTIME_ID, &before);
    solvePrim(graph, n);
    clock_gettime(CLOCK_PROCESS_CPUTIME_ID, &after);

    struct timespec *delta = diff(before, after);
    return delta -> tv_nsec;
}
