#include "types.h"
#include <cstdio>
#include <ctime>
#include <cstdlib>

#define CAPACITY_LIMIT 20
#define FILE_NAME "./mygrtmp.txt"
#define EX_FLOW 5

/*
 * A = 0
 * B = 1 
 * C = 2
 * D = 3
 * E = 4 
 * F = 5
 */

int getMaxFlow(Graph &net, int source, int sink);

Graph getGraph()
{
    char buffer[32];
    FILE *file = fopen(FILE_NAME, "r");
    if(file == NULL)
    {
    }
    int n = 6;

    Graph result = Graph(n);

    while(fgets(buffer,32, file) != NULL)
    {
        int to,from, capacity;
        sscanf(buffer, "%d %d %d\n", &to, &from, &capacity);

        result[from].push_back(Edge(from, to, capacity, 0));
        result[to].push_back(Edge(to, from, capacity, 0));
    }

    return result;
}

void printGraph(Graph &gr);

int main()
{
    time_t t;
    srand(time(&t));

    Graph net = getGraph();
    int flow = getMaxFlow(net, 0, 5);
    printGraph(net);
    printf("%d\n", flow);


    return 0;
}

void printGraph(Graph &gr)
{
    for(int i = 0; i < gr.size(); i++)
    {
        printf("Node %d\n",i);

        for(int j = 0; j < gr[i].size(); j++)
        {
            printf("To %d capacity %d flow %d\n", gr[i][j].to, gr[i][j].capacity, gr[i][j].flow);
        }
        printf("\n\n");
    }
}

